# boek/omroeper.py
#
#

""" basic package for the program. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from boek.helpers import get_name, short_date, get_type
from boek.fouten import RemoteDisconnect
from boek.definitie import BLA, ENDC
from boek.schuiver import Schuiver
from boek.kern import kern, fleet
from boek.ding import Ding

import logging
import socket
import time

## BOTS

class Omroep(Schuiver):

    """ Base Bot class. """

    def __init__(zelf, *args, **kwargs):
        Schuiver.__init__(zelf, *args, **kwargs)
        zelf._start = time.time()
        zelf.channels = ["#boek", ]

    def say(zelf, *args, **kwargs): print(args[1])
        
    ## CHANNELS

    def announce(zelf, *args, **kwargs):
        """ announce on channels. """
        zelf.wait()
        logging.info("# announce %s" % " ".join(zelf.channels))
        for channel in zelf.channels: zelf.say(channel, args[0])

    def join(zelf, *args, **kwargs): pass
        
    def join_channels(zelf, *args, **kwargs):
        """ join channels.  """ 
        for channel in zelf.channels: zelf.join(channel)
            
## TESTBOT

class TestOmroep(Omroep):

    """ USE WITH Bot.put() and Bot.read(). """

    testing = True

    def say(zelf, *args, **kwargs): logging.warn(args[1])

    def event(zelf, *args, **kwargs):
        o = Ding()
        o.origin = "test@boek"
        o._target = zelf
        o.meldinglevel = "warning"
        return o
