# boek/bots/cli.py
#
#

""" basic package for the program. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from boek.definitie import BLA, GREEN, ENDC, pfc
from boek.fouten import RemoteDisconnect
from boek.kern import fleet, regels
from boek.helpers import short_date
from boek.ding import Ding
from boek.omroep import Omroep

import logging
import time
import sys

## CLI

class CLI(Omroep):

    """ bot running on the console. """

    cc = ""

    def _raw(zelf, *args, **kwargs): sys.stdout.write(args[0] + "\n") ; sys.stdout.flush()

    def say(zelf, *args, **kwargs): zelf._raw(args[1])

    def prompt(zelf, *args, **kwargs):
        zelf.wait()
        return "%s %s<%s " % (short_date(time.ctime(time.time())).split()[1], GREEN, ENDC)

    def event(zelf, *args, **kwargs):
        event = Ding()
        event._target = zelf
        event.origin = "root@shell"
        event.cc = zelf.cc
        zelf.ready()
        event.txt = input(zelf.prompt())
        return event

    def start(zelf, *args, **kwargs):
        fleet.append(zelf)
        if not regels.shell:
            thrs = zelf.single(" ".join(regels.runargs))
            if thrs: zelf.collect(thrs)
            return
        Omroep.start(zelf)
