# boek/regels.py
#
#

""" default configurations. """

__copyright__ = "Copyright 2015, B.H.J Thate"

from boek.definitie import homedir
from boek.ding import Ding
from boek.helpers import j

import os
import os.path
import socket

## XMPP

regels_xmpp = Ding()
regels_xmpp.server = "localhost"
regels_xmpp.username = "boek"
regels_xmpp.channel = "#boek"
regels_xmpp.nick = "boek"
regels_xmpp.regels = "xmpp"
regels_xmpp.user = "boek@localhost"

## IRC

regels_irc = Ding()
regels_irc.server = "localhost"
regels_irc.username = "boek"
regels_irc.channel = "#boek"
regels_irc.nick = "boek"
regels_irc.regels = "irc"

## KERNEL

regels_kernel = Ding()
regels_kernel.debug = False
regels_kernel.background = False
regels_kernel.openfire = False
regels_kernel.shell = False
regels_kernel.init = ""
regels_kernel.workdir = ""
regels_kernel.meldinglevel = "error"
regels_kernel.packages = ["boek.omroeper", "boek.diensten", "boek.werken"]
regels_kernel.regels = "kernel"

# UDP

regels_udp = Ding()
regels_udp.regels = "udp"
regels_udp.host = "localhost"
regels_udp.port = 5500
regels_udp.password = "boh"
regels_udp.seed = "blablablablablaz" # needs to be 16 chars wide

## API

regels_api = Ding()
regels_api.regels = "api"
regels_api.hostname = socket.getfqdn()
regels_api.port = 10102
