# boek/plugs/input.py
#
#

""" commenting. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from boek.helpers import j, error, parse_email, short_date, ftime, graai_url
from boek.ding import Ding
from boek.kern import kern

import email.message
import datetime
import mailbox
import logging
import socket
import email
import time
import os

## CMNDS

def lees_opmerking(event):
    objs = event.selected()
    if not objs: return
    obj = objs[0]
    if "comment" not in obj: obj.comment = []
    obj.comment.append(" ".join(event.args[2:]))
    obj.sync()
    event.ok()

kern.register("lees.opmerking", lees_opmerking)

def input_melding(event):
    o = Ding()
    o.prefix = "melding"
    o.ctype = "melding"
    o.melding = event.rest()
    o.save()
    event.ok()

kern.register("lees.melding", input_melding)

def lees_toestand(event):
    o = Ding()
    o.prefix = "status"
    o.status = event.rest()
    o.save()
    event.ok()

kern.register("lees.toestand", lees_toestand)

def lees_post(event):
    try: fn = os.path.abspath(os.path.expanduser(event.args[0]))
    except: return
    nr = 0
    if not os.path.isfile(fn): event.reply("a mbox file is needed.") ; return
    for m in mailbox.mbox(fn, create=False):
        o = Ding()
        o.update(m.items())
        try: sdate = os.sep.join(short_date(o.Date).split())
        except AttributeError: sdate = None
        o.text = ""
        for load in m.walk():
            if load.get_content_type() == 'text/plain': o.text += load.get_payload()
        o.text = o.text.replace("\\n", "\n")
        o.prefix = "email"
        if sdate: o.save(sdate)
        else: o.save()
        nr += 1
    if nr: event.ok(nr)

kern.register("lees.post", lees_post)

def lees_overkant(event):
    rest = event.rest()
    if not rest: return
    try: result = graai_url("GET", rest + "/all").read()
    except socket.gaierror as ex: event.reply(str(ex)) ; return
    obj_list = json.loads(str(result, "utf-8"))
    for nr, url in obj_list.items():
        res = graai_url("GET", url).read()
        obj = json.loads(str(res, "utf-8"))
        o = Ding()
        o.update(obj)
        o.save()

kern.register("lees.overkant", lees_overkant)
