# boek/werken/opslag.py
#
#

""" add a value. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from boek.helpers import short_date
from boek.ding import Ding
from boek.kern import kern

import logging
import time
import os

## CMNDS

def opslag_erbij(event):
    rest = event.rest()
    try: key, value = rest.split(" ", 1)
    except ValueError: return
    o = Ding()
    if key in dir(o): event.reply("%s already defined in default Ding" % key) ; return
    o.prefix = "add"
    o[key] = value
    path = o.save()
    event.ok()

kern.register("opslag.erbij", opslag_erbij)

def opslag_verdwenen(event):
    if not event.args: return
    nr = 1
    for obj in kern.all("foetsie"): event.reply(obj.format(nr)) ; event.reply("") ; nr += 1 

kern.register("opslag.verdwenen", opslag_verdwenen)

## 

def opslag_weg(event):
    try: key, match = event.args
    except ValueError: return
    nr = 0
    for obj in kern.dings():
       if key not in obj: continue
       if match not in obj[key]: continue
       obj.deleted = True
       obj.sync()
       nr += 1
    event.ok(nr)

kern.register("opslag.weg", opslag_weg)

def opslag_terug(event):
    try: key, match = event.args
    except ValueError: return
    nr = 0
    for obj in kern.dings(**{"full": True}):
       if key not in obj: continue
       if match not in obj[key]: continue
       if "deleted" not in obj: continue
       obj.deleted = False
       obj.sync()
       nr += 1
    event.ok(nr)

kern.register("opslag.terug", opslag_terug)

def opslag_zoek(event):
    if not event.args: return
    objs = sorted(event.selected(), key=lambda x: x.get_timed())
    event.display_list(objs, keys=event.args)

kern.register("opslag.zoek", opslag_zoek)

def opslag_toon(event):
    if not event.args: return
    objs = sorted(event.selected(event), key=lambda x: x.get_timed())
    try: event.reply(str(objs[event.index]))
    except:
        for obj in objs: event.reply(str(obj))

kern.register("opslag.toon", opslag_toon)

def opslag_eerste(event):
    if not event.args: return
    obj = kern.first(event.args[0])
    if obj: event.reply(obj.json())

kern.register("opslag.eerste", opslag_eerste)

def opslag_laatste(event):
    if not event.args: return
    obj = kern.last(event.args[0])
    if obj: event.reply(obj.json())

kern.register("opslag.laatste", opslag_laatste)

def opslag_omschrijf(event):
    if not event.args: return
    objs = sorted(kern.selected(event), key=lambda x: x.get_timed())
    event.reply_list(objs, skiplist=["saved", "ctype", "prefile"])
    
kern.register("opslag.omschrijf", opslag_omschrijf)

def opslag_tekst(event):
    if not event.args: return
    rest = event.rest()
    objs = sorted(kern.full(event), key=lambda x: x.get_timed())
    nr = 1
    for obj in objs:
        if obj.search(rest): event.reply("\n" + obj.format(nr, skiplist=["saved"])) ; nr += 1

kern.register("opslag.tekst", opslag_tekst)
