#!/usr/bin/env python3
#
#

import os
import sys

if sys.version_info.major < 3: print("you need to run BOEK with python3") ; os._exit(1)

try: use_setuptools()
except: pass

try:
    from setuptools import setup
except Exception as ex: print(str(ex)) ; os._exit(1)

from distutils import sysconfig
site_packages_path = sysconfig.get_python_lib()

setup(
    name='boek',
    version='2',
    url='https://pikacode.com/bthate/boek',
    author='Bart Thate',
    author_email='bthate@dds.nl',
    description="BOEK - XMPP - IRC - CLI - RSS - UDP - API",
    license='MIT',
    include_package_data=True,
    zip_safe=False,
    install_requires=["beautifulsoup4", "sleekxmpp", "feedparser"],
    scripts=["bin/boek", "bin/boek-sed", "bin/boek-local", "bin/boek-docs", "bin/boek-udp"],
    packages=['boek',
              'boek.diensten',
              'boek.extra',
              'boek.omroeper',
              'boek.werken',
             ],
    long_description = """ 

Scripturen die vanuit de Hemel de hel voor de mens uitleggen, komen dat boek
dan ook brengen.
Een woord dat zo slecht uitpakt, dien je dan ook tegen in opstand te komen,
anders vind je de Schepper niet.

Het is tijd voor een nieuw boek, niet wat voor de mens de Hemel maakt, 
maar dat de mens op Aarde hier de Schepper kan helpen om de Schepping tot
bloei te laten komen.

""",
    classifiers=[
        'Development Status :: 4 - Beta',
        'License :: OSI Approved :: MIT License',
        'Operating System :: Unix',
        'Programming Language :: Python',
        'Topic :: Software Development :: Libraries :: Python Modules'],
)
